package com.yyge.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
public class RedisSeckill {

    @Autowired
    StringRedisTemplate stringRedisTemplate;

    @RequestMapping("/deduct_stock")
    public String deductStock(){
       //查询redis里的库存 假设查询结果是200
       int stock = Integer.parseInt(stringRedisTemplate.opsForValue().get("stock"));

       //如果库存结果大于0
       if(stock > 0){
           int realStock = stock - 1; //库存-1  当在高并发情况下多个线程都扣减1 200-1结果为199
           stringRedisTemplate.opsForValue().set("stock", String.valueOf(realStock)); //重新设置库存
           System.out.println("扣减成功，剩余库存:" + realStock); //线程1、线程2...都输出199
           //出现数据不一致的BUG问题
       }else{
           //否则库存扣减失败
           System.out.println("扣减失败，库存不足");
       }
       return "end";
    }
}
