package com.yyge.controller;

import org.redisson.Redisson;
import org.redisson.api.RLock;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
public class resolve5 {

    @Autowired
    Redisson redisson;

    @Autowired
    StringRedisTemplate stringRedisTemplate;

    @RequestMapping("/deduct_stock")
    public String deductStock(){
        String lockKey="lock:product:id"; //根据商品ID生产一个KEY,商品ID是前端传过来的

        //获得锁对象
        RLock redissonLock = redisson.getLock(lockKey);
        redissonLock.lock(); //加锁
        try {
            //查询redis里的库存 假设查询结果是200
            int stock = Integer.parseInt(stringRedisTemplate.opsForValue().get("stock"));
            //如果库存结果大于0
            if(stock > 0){
                int realStock = stock - 1; //库存-1  结果为199
                stringRedisTemplate.opsForValue().set("stock", String.valueOf(realStock)); //重新设置库存
                System.out.println("扣减成功，剩余库存:" + realStock); //输出199
            }else{
                //否则库存扣减失败
                System.out.println("扣减失败，库存不足");
            }
        }finally {
            redissonLock.unlock(); //释放锁
        }
        return "end";
    }
}
